import hu.bme.mit.books.manager.BookManager;
import hu.bme.mit.books.model.Book;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.List;
import java.util.Scanner;

/**
 * 
 */

/**
 * This class contains a menu with console input and output.
 * @author meres
 *
 */
public class Menu {
	
	/**
	 * Display menu.
	 * 
	 * @return the int
	 */
	public static int displayMenu(){
		System.out.println("1 Add book");
		System.out.println("2 List books");
		System.out.println("3 List read books");
		System.out.println("4 List books of author");
		System.out.println("0 Exit");
		System.out.print("Select one:  ");
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String str;
		try {
			str = in.readLine();
			return Integer.parseInt(str);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			//e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			//e.printStackTrace();
		}
		
		return -1;
	}
	
	static void printBooks(List<Book> books){
		for (Book book: books){
			System.out.println(book);
		}
		System.out.println("---------");
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		int no = -1;
		BookManager manager = new BookManager();
		while(no != 0){
			no = displayMenu();
			List<Book> books;
			BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
			switch(no){
			case 1:
				String author, title;
				int pageNum;
				boolean read;
				try {
					System.out.print("Enter author name: ");
					author = in.readLine();
					System.out.print("Enter book title: ");
					title = in.readLine();
					System.out.print("Enter number of pages: ");
					pageNum = Integer.parseInt(in.readLine());
					System.out.print("Is the book read? ");
					read = Boolean.parseBoolean(in.readLine());
					manager.addBook(author, title, pageNum, read);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				break;
			case 2:
				books = manager.getAllBooks();
				printBooks(books);
				break;
			case 3:
				books = manager.getReadBooks();
				printBooks(books);
				break;
			case 4:
				try {
					String str;
					System.out.print("Enter author name: ");
					str = in.readLine();
					books = manager.getBookOfAuthor(str);
					System.out.println("Listing books of " + str);
					printBooks(books);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				break;
			default:
				break;
			}
		}

	}

}
