import hu.bme.mit.books.manager.BookManager;
import hu.bme.mit.books.model.Book;

import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Button;

public class BookComposite extends Composite {

	private Label label = null;
	private Text text = null;
	private Label label1 = null;
	private Text text1 = null;
	private Label label2 = null;
	private Text text2 = null;
	private Button checkBox = null;
	private Button button = null;
	private Button button1 = null;
	private BookManager manager;
	private int bookID;

	public BookComposite(Composite parent, int style) {
		super(parent, style);
		initialize();
	}

	private void initialize() {
		label = new Label(this, SWT.NONE);
		label.setText("Author");
		text = new Text(this, SWT.BORDER);
		label1 = new Label(this, SWT.NONE);
		label1.setText("Title");
		text1 = new Text(this, SWT.BORDER);
		label2 = new Label(this, SWT.NONE);
		label2.setText("PageNum");
		text2 = new Text(this, SWT.BORDER);
		checkBox = new Button(this, SWT.CHECK|SWT.BORDER);
		checkBox.setText("Read");
		button = new Button(this, SWT.NONE);
		button.setText("Previous");
		button.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				bookID--;
				refreshBookData();
			}
		});
		button1 = new Button(this, SWT.NONE);
		button1.setText("Next");
		button1.addSelectionListener(new org.eclipse.swt.events.SelectionAdapter() {
			public void widgetSelected(org.eclipse.swt.events.SelectionEvent e) {
				bookID++;
				refreshBookData();
			}
		});
		this.setLayout(new GridLayout(2, true));
		setSize(new Point(300, 200));
		GridData gridData = new GridData();
		gridData.horizontalSpan = 2;
		gridData.grabExcessHorizontalSpace = true;
		checkBox.setLayoutData(gridData);
		//setLayout(new GridLayout(2, true));
	}

	public void setManager(BookManager manager) {
		this.manager = manager;
		bookID = 0;
		refreshBookData();
	}
	
	private void refreshBookData() {
		Book book = manager.getBookOfID(bookID);
		text.setText(book.getAuthor());
		text1.setText(book.getTitle());
		text2.setText(Integer.toString(book.getPageNum()));
		checkBox.setSelection(book.isRead());
		button.setEnabled(bookID != 0);
		button1.setEnabled(bookID < manager.getNumberOfBooks() - 1);
	}

}  //  @jve:decl-index=0:visual-constraint="249,13"
